"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CoreMenu = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const core_model_detail_entity_1 = require("../../../core/core-model-details/entities/core-model-detail.entity");
const core_page_definition_entity_1 = require("../../../core/core-page-definitions/entities/core-page-definition.entity");
let CoreMenu = class CoreMenu extends sequelize_typescript_1.Model {
};
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.INTEGER,
        primaryKey: true,
        allowNull: false,
        autoIncrement: true,
    }),
    __metadata("design:type", Number)
], CoreMenu.prototype, "id", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.BIGINT,
        allowNull: true,
    }),
    __metadata("design:type", Number)
], CoreMenu.prototype, "created_by", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.BIGINT,
        allowNull: true,
    }),
    __metadata("design:type", Number)
], CoreMenu.prototype, "updated_by", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.DATE,
        allowNull: true,
    }),
    __metadata("design:type", Date)
], CoreMenu.prototype, "deleted_at", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.DATE,
        allowNull: true,
    }),
    __metadata("design:type", Date)
], CoreMenu.prototype, "updated_at", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.DATE,
        allowNull: true,
    }),
    __metadata("design:type", Date)
], CoreMenu.prototype, "created_at", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.BIGINT, allowNull: true }),
    __metadata("design:type", Number)
], CoreMenu.prototype, "code", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 50 }),
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.STRING, allowNull: true }),
    __metadata("design:type", String)
], CoreMenu.prototype, "name", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 255 }),
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.STRING, allowNull: true }),
    __metadata("design:type", String)
], CoreMenu.prototype, "path", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 255 }),
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.STRING, allowNull: true }),
    __metadata("design:type", String)
], CoreMenu.prototype, "route", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.INTEGER, allowNull: true }),
    __metadata("design:type", Number)
], CoreMenu.prototype, "page_id", void 0);
__decorate([
    (0, sequelize_typescript_1.HasOne)(() => core_page_definition_entity_1.CorePageDefinition, {
        foreignKey: "id",
        sourceKey: "page_id",
    }),
    __metadata("design:type", core_page_definition_entity_1.CorePageDefinition)
], CoreMenu.prototype, "page", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.INTEGER, allowNull: true }),
    __metadata("design:type", Number)
], CoreMenu.prototype, "model_id", void 0);
__decorate([
    (0, sequelize_typescript_1.HasOne)(() => core_model_detail_entity_1.CoreModelDetail, {
        foreignKey: "id",
        sourceKey: "model_id",
    }),
    __metadata("design:type", core_model_detail_entity_1.CoreModelDetail)
], CoreMenu.prototype, "model", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 50 }),
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.STRING, allowNull: true }),
    __metadata("design:type", String)
], CoreMenu.prototype, "caption", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 50 }),
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.STRING, allowNull: true }),
    __metadata("design:type", String)
], CoreMenu.prototype, "description", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 3 }),
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.STRING, allowNull: true }),
    __metadata("design:type", String)
], CoreMenu.prototype, "type", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 1 }),
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.STRING, allowNull: true }),
    __metadata("design:type", String)
], CoreMenu.prototype, "drop_down_style", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.INTEGER, allowNull: true }),
    __metadata("design:type", Number)
], CoreMenu.prototype, "serial_number", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.INTEGER, allowNull: true }),
    __metadata("design:type", Number)
], CoreMenu.prototype, "step", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.BIGINT, allowNull: true }),
    __metadata("design:type", Number)
], CoreMenu.prototype, "header_id", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.BIGINT, allowNull: true }),
    __metadata("design:type", Number)
], CoreMenu.prototype, "sub_header_id", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 10 }),
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.STRING, allowNull: true }),
    __metadata("design:type", String)
], CoreMenu.prototype, "string_serial_number", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 3 }),
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.STRING, allowNull: true }),
    __metadata("design:type", String)
], CoreMenu.prototype, "event_action_type", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 500 }),
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.STRING, allowNull: true }),
    __metadata("design:type", String)
], CoreMenu.prototype, "page_name", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 100 }),
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.STRING, allowNull: true }),
    __metadata("design:type", String)
], CoreMenu.prototype, "arguments_string", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 100 }),
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.STRING, allowNull: true }),
    __metadata("design:type", String)
], CoreMenu.prototype, "tool_tip", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({ allowNull: true }),
    __metadata("design:type", Boolean)
], CoreMenu.prototype, "is_available", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({ allowNull: true }),
    __metadata("design:type", Boolean)
], CoreMenu.prototype, "is_visible", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({ allowNull: true }),
    __metadata("design:type", Boolean)
], CoreMenu.prototype, "show_icon", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 50 }),
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.STRING, allowNull: true }),
    __metadata("design:type", String)
], CoreMenu.prototype, "icon_name", void 0);
__decorate([
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.INTEGER, allowNull: true }),
    __metadata("design:type", Number)
], CoreMenu.prototype, "firm_id", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 500 }),
    (0, sequelize_typescript_1.Column)({ type: sequelize_typescript_1.DataType.STRING, allowNull: true }),
    __metadata("design:type", String)
], CoreMenu.prototype, "attributes", void 0);
CoreMenu = __decorate([
    (0, sequelize_typescript_1.Table)({
        tableName: "core_menus",
        timestamps: true,
        paranoid: true,
        deletedAt: "deleted_at",
        createdAt: "created_at",
        updatedAt: "updated_at",
    })
], CoreMenu);
exports.CoreMenu = CoreMenu;
