"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.coreUserRolesProviders = void 0;
const constants_1 = require("../../common/constants");
const role_entity_1 = require("../roles/entities/role.entity");
const user_entity_1 = require("../users/entities/user.entity");
const user_role_entity_1 = require("./entities/user-role.entity");
exports.coreUserRolesProviders = [
    {
        provide: constants_1.CORE_USER_ROLES,
        useValue: user_role_entity_1.UserRole,
    },
    {
        provide: constants_1.CORE_USERS,
        useValue: user_entity_1.User,
    },
    {
        provide: constants_1.CORE_ROLES,
        useValue: role_entity_1.Role,
    },
];
