"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WusergrpNura = exports.WusergrpAlsalama = exports.Wusergrp = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
let Wusergrp = class Wusergrp extends sequelize_typescript_1.Model {
};
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 5 }),
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: true,
        primaryKey: true
    }),
    __metadata("design:type", String)
], Wusergrp.prototype, "wug_code", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 30 }),
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: true
    }),
    __metadata("design:type", String)
], Wusergrp.prototype, "wug_desc", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 0 }),
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: true
    }),
    __metadata("design:type", String)
], Wusergrp.prototype, "wug_menuids", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 20 }),
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: true
    }),
    __metadata("design:type", String)
], Wusergrp.prototype, "wug_general", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 100 }),
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: true
    }),
    __metadata("design:type", String)
], Wusergrp.prototype, "wug_phmbtypes", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 500 }),
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: true
    }),
    __metadata("design:type", String)
], Wusergrp.prototype, "wug_phmbdepts", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 500 }),
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: true
    }),
    __metadata("design:type", String)
], Wusergrp.prototype, "wug_phmstores", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 100 }),
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: true
    }),
    __metadata("design:type", String)
], Wusergrp.prototype, "wug_opbtypes", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 100 }),
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: true
    }),
    __metadata("design:type", String)
], Wusergrp.prototype, "wug_ipbtypes", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 1000 }),
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: true
    }),
    __metadata("design:type", String)
], Wusergrp.prototype, "wug_custreportids", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 100 }),
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: true
    }),
    __metadata("design:type", String)
], Wusergrp.prototype, "wug_labresultavmodes", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 1 }),
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: true
    }),
    __metadata("design:type", String)
], Wusergrp.prototype, "wug_opresvtokaccess", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 1 }),
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: true
    }),
    __metadata("design:type", String)
], Wusergrp.prototype, "wug_firmptr", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 1 }),
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: true
    }),
    __metadata("design:type", String)
], Wusergrp.prototype, "wug_active", void 0);
__decorate([
    (0, sequelize_typescript_1.Length)({ max: 2500 }),
    (0, sequelize_typescript_1.Column)({
        type: sequelize_typescript_1.DataType.STRING,
        allowNull: true
    }),
    __metadata("design:type", String)
], Wusergrp.prototype, "wug_dashboardids", void 0);
Wusergrp = __decorate([
    (0, sequelize_typescript_1.Table)({ tableName: "wusergrp", timestamps: false })
], Wusergrp);
exports.Wusergrp = Wusergrp;
class WusergrpAlsalama extends Wusergrp {
}
exports.WusergrpAlsalama = WusergrpAlsalama;
class WusergrpNura extends Wusergrp {
}
exports.WusergrpNura = WusergrpNura;
